﻿/*=================================================================================================================

■GBA版FE救出判定

〇概要
　GBA版FEの救出判定ができます。
　歩兵系：自分の体格-1が相手の体格以上の時、救出できる
　騎馬系または飛行系の男性：25-自分の体格が相手の体格以上の時、救出できる
　騎馬系または飛行系の女性：20-自分の体格が相手の体格以上の時、救出できる

〇こんなときに使います
　自作ゲームをGBA版FEの救出判定にしたいとき。

〇使い方
　この「GBA版FE救出判定.js」をプロジェクトファイルの「Plugin」フォルダに入れてください。

〇注意
　下記「〇前提」をよくお読みください。デフォルトの設定のままであれば普通に使えますが、移動タイプや種族を弄っている場合はこのプラグインは正常に動作しません。
　本プラグインの改変が必要になります。
　また、「データ設定」⇒「コンフィグ」⇒「フュージョン設定」の設定内容は本プラグインを導入することによって無効化されます。

〇前提
　・クラスタイプではなく移動タイプにて、騎馬系なのか、飛行系なのか、騎馬系でも飛行系でもないのか、を判定しています
　・移動タイプIDが2は騎馬、3は大空（※デフォルトの設定）
　・種族IDが0は男性、1は女性（※デフォルトの設定）

〇履歴
　2017/06/24 公開

〇対応バージョン
　SRPG Studio Version:1.129

〇連絡先
　・シルバーティアラの行方 - お問い合わせフォーム		https://silvertiara.click/other/contact
　・レリーズ（シルバーティアラの行方作者）titterアカウント	https://twitter.com/ReleaseCarte

〇利用規約
　改変：OK
　改変したものを公開：OK
　再配布：OK
　商用での使用：OK
　作成者の偽り：NG
　著作権表記：必要ありません（記載したいという場合は「Release」または「レリーズ」でお願いします）
　作成者を偽らなければ基本的に全部OKです。

=================================================================================================================*/

(function() {
var alias1 = FusionControl.isFusionAllowed;
FusionControl.isFusionAllowed = function (unit, targetUnit, fusionData) {

// 既存のフュージョン設定をコメントアウトで無効化
//		if (!fusionData.compareUnitCapacity(unit, targetUnit)) {
//			return false;
//		}

	var	moveTypeId = unit.getClass().getClassType().getMoveTypeId();
	
	// 移動タイプIDが2は騎馬、3は大空
	if(moveTypeId==2 || moveTypeId==3){
		var genderId;
		var refList = unit.getClass().getRaceReferenceList();
		var count = refList.getTypeCount();
			
		for (i = 0; i < count; i++) {
			data = refList.getTypeData(i);
			raceId = data.getId();
			// 種族IDが0は男性
			if (raceId === 0) {
				genderId = 0;
			// 種族IDが1は女性
			}else if(raceId === 1){
				genderId = 1;
			}
		}

		if(genderId==0){
			if(!(25 - ParamBonus.getBld(unit) >= ParamBonus.getBld(targetUnit))){
				return false;
			}
		}else{
			if(!(20 - ParamBonus.getBld(unit) >= ParamBonus.getBld(targetUnit))){
				return false;
			}
		}
	}else{
		if(!((ParamBonus.getBld(unit)-1) >= ParamBonus.getBld(targetUnit))){
			return false;
		}
	}
	if (!fusionData.isSrcCondition(unit)) {
		return false;
	}
	
	if (!fusionData.isDestCondition(targetUnit)) {
		return false;
	}
	
	return true;
};

})(); 